NotPushJump:macro N, NL
    errorlevel -207		    ; for code justifying
    local port
    local pin
    
    if N == 1
	port = PORTB
	pin = RB0
    endif
    
    if N == 2
	port = PORTB
	pin = RB4
    endif
    
    if N == 3
	port = PORTB
	pin = RB1
    endif
    
    if N < 1 || N > 3
	error "Wrong switch number"
	exitm
    endif
    
    BTFSC	port,pin
    GOTO	NL
PushJump_l1:
PushJump_l2:
PushJump_l3:
    errorlevel +207		    ; for code justifying
    endm
    
LedOn:macro N
    errorlevel -207		    ; for code justifying
    local port
    local pin
    
    if N == 1
	port = PORTC
	pin = RC0
    endif
    if N == 2
	port = PORTB
	pin = RB2
    endif
    if N == 3
 	port = PORTC
	pin = RC1
    endif
    if N < 1 || N > 3
	error "Wrong switch number"
	exitm
    endif
    
    BSF		port, pin
    errorlevel +207		    ; for code justifying
    endm
    
LedOff:macro N
    errorlevel -207		    ; for code justifying
    local port
    local pin
    
    if N == 1
	port = PORTC
	pin = RC0
    endif
    if N == 2
	port = PORTB
	pin = RB2
    endif
    if N == 3
 	port = PORTC
	pin = RC1
    endif
    if N < 1 && N > 3
	error "Wrong switch number"
	exitm
    endif
    
    BCF		port, pin
    errorlevel +207		    ; for code justifying
    endm
    
DelayUs:MACRO T
    errorlevel -207		    ; for code justifying
    
    if T >= (256*197122)+7
	error "Too large T value"
	exitm
    endif
    
    local t = (T)
    local w

    w = ((t-C3) / T3)
    
    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delaySec
	t = ((t-C3) % T3)
    endif
    
    w = (((t)-C2) / T2)

    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delayMsF
	t = (((t)-C2) % T2)
    endif

    w = (((t)-C1) / T1)
    
    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delayUsF
	t = (((t)-C1) % T1)
    endif
    
    w = t
    
    while w > 1
	GOTO	$+1
	w -= 2
    endw
    
    while w > 0
	NOP
	w -= 1
    endw
    
    errorlevel +207		    ; for code justifying
    ENDM

#define FC (1) ; fclk [MHz]
    
#define C1  (5/FC)
#define T1  (3/FC)

delayUsF:
    DECFSZ	delay1_cnt,F
    GOTO	delayUsF
    RETLW	0

#define C2    (6/FC)
#define T2    (770/FC)

delayMsF:
    CLRF	delay2_cnt
delayMsFStart:    
    DECFSZ	delay2_cnt,F
    GOTO	delayMsFStart
    DECFSZ	delay1_cnt,F
    GOTO	delayMsFStart
    RETLW	0
    
#define C3    (7/FC)
#define T3    (197122/FC)
    
delaySec:
    CLRF	delay2_cnt
    CLRF	delay3_cnt
delaySecStart:
    DECFSZ	delay3_cnt,F
    GOTO	delaySecStart
    DECFSZ	delay2_cnt,F
    GOTO	delaySecStart
    DECFSZ	delay1_cnt,F
    GOTO	delaySecStart
    RETLW	0


SetPinH:MACRO PORT_NAME,PIN_NAME,TRIS_NAME
    BSF		PORT_NAME, PIN_NAME
    BCF		TRIS_NAME, PIN_NAME
    MOVF	TRIS_NAME,W
    TRIS	PORT_NAME
    ENDM
    
OwOutH:MACRO
    SetPinH DS18B20_PORT,DS18B20_PIN,tris_masq_c
    ENDM  
    
; jump to label G if R is less than constans L
; if R < L GOTO G    
JL:MACRO R, L, G
    MOVLW	L
    SUBWF	R,W
    BTFSS	STATUS,C
    GOTO	G
    ENDM

; jump to label G if R is less than L or equals
; if R <= L GOTO G    
JLE:MACRO R, L, G
    MOVLW	L ; L
    SUBWF	R, W
    BTFSC	STATUS, Z
    GOTO	G
    SUBWF	R, W
    BTFSS	STATUS,C
    GOTO	G
    ENDM
    
; jump to label G if R is grather than L    
; if R > L GOTO G    
JG:MACRO R, L, G   
    MOVLW	L ; L
    SUBWF	R, W
    BTFSC	STATUS,Z
    GOTO	$+5
    SUBWF	R, W
    BTFSS	STATUS,C
    GOTO	$+2
    GOTO	G
    ENDM

    
; jump to label G if R is grather than L or equals
; if R >= L GOTO G    
JGE:MACRO R, L, G
    MOVLW	L
    SUBWF	R,W
    BTFSC	STATUS,C
    GOTO	G        
    ENDM